
#include <stdio.h>
#include <stdlib.h>

#include "2443addr.h"
#include "System.h"
#include "Exception.h"
#include "Console.h"
#include "MMUCache.h"
#include "dram.h"
#include "PLL.h"

#include "IIS.h"

#include "IIC.h"
#include "Display.h"
#include "DisplaySample.h"
#include "DisplaySample_240_320.h"
#include "DisplaySample_320_240.h"
//extern void Test_LCD(void);



void *function[][2]=
{   //  							"123456789012345678901"

	(void *) Test_IIS,				(char *)"WM8960 Codec Test             ",
	(void *) Test_LCD,			(char *)"Mango LCD Test            ",	
	0,0
};



int main( void)
{
	int i;

	PreChangeSDRAMParameter();
	
	rGPHCON=rGPHCON&~(0xf<<26)|(0xa<<26);
	rMISCCR=rMISCCR&~((0x7<<8)|(0x7<<4))|(0x3<<8)|(0x2<<4);

	// test code start setting in option.h
	SetCLKDIV( Startup_ARMCLKdiv, Startup_PREdiv, Startup_HCLKdiv, Startup_PCLKdiv);
	SetMPLL( Startup_MDIV, Startup_PDIV, Startup_SDIV);



	SystemCLK(0);
	ChangeSDRAMParameter(HCLK);
	
	Max1718_Init();

	
	Isr_Init();
	MMU_Init();


    Delay(0); //calibrate Delay()
    
//--------------------------------------------------------------------------------------------

    while(1)
    {
 		Console();

		
	   	printf("\n\nSMDK2443 Test Program Ver 0.0 (20060525)\n");
	   	printf("MPLL=%.2fMHz, ARMCLK=%.2fMHz (%d:%d:%d), HCLK=%.2fMHz, PCLK=%.2fMHz\n\n",
	   		(float)MPLL/1000000,(float)ARMCLK/1000000,ARMCLKdiv+1,(ARMCLKdiv+1)*(HCLKdiv+1),(ARMCLKdiv+1)*(HCLKdiv+1)*(PCLKdiv+1),(float)HCLK/1000000,(float)PCLK/1000000);

		i = 0;
		while(1)
		{   //display menu
	    	printf("%2d:%s",i,function[i][1]);
	    	i++;
	    	if((int)(function[i][0])==0)
	    	{
				printf("\n");
				break;
	    	}
	    	if((i%2)==0) printf("\n");
		}

		printf("\nSelect the function to test : ");
		i = GetIntNum();
		printf("\n");

		if( i>=0 && (i<sizeof(function)/8-1) ) 
		   ( (void (*)(void)) (function[i][0]) )();
    }	
}

