/**
* Project Name : Jelly(S3C2443) verification project
*
* Copyright 2008 by Embedded Crazy boys.Inc
* All rights reserved.
*
* Project Description :
* This software is only for verifying functions of the Jelly(S3C2443) . 
* Anybody can use this code.
*/

/**
* File Name    : memtest.c
* Description  : Jelly(S3C2443)  USB monitor main code
* Author       : http://cafe.naver.com/embeddedcrazyboys
* Dept         : Mobile solution, AP
* Created Date : 2008.07.04
* Version      : 0.0
* History
*   R0.0 (2006.08.): http://cafe.naver.com/embeddedcrazyboys
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Option.h"
#include "2443addr.h"
#include "Console.h"
#include "def.h"
#include "memtest.h"

#define	SRAM_SADDR	_NONCACHE_STARTADDRESS
#define	SRAM_EADDR	(SRAM_SADDR+ (128*1024))	// Total : 256KB, 0x3100_0000-0x3101_FFFF





void *function[][2]=
{   //  							"123456789012345678901"
	(void *) MemoryTest,				(char *)"Memory RW test     ",
	(void *) ClearMemory,				(char *)"0x0 Init Clear    ",		

	0,0
};

int MemoryTest_main( void)
{
	int i;
   

    while(1)
    {

		while(1)
		{   //display menu
	    	printf("%2d:%s",i,function[i][1]);
	    	i++;
	    	if((int)(function[i][0])==0)
	    	{
				printf("\n");
				break;
	    	}
	    	if((i%4)==0) printf("\n");
		}

		printf("\nSelect the function to test : ");
		i = GetIntNum();
		printf("\n");

		if( i>=0 && (i<sizeof(function)/8-1) ) 
		   ( (void (*)(void)) (function[i][0]) )();
    }	
}


// for USB mon code - modified by cha 
void MemoryTest(void)
{
    volatile unsigned int *pt;
	volatile unsigned int data;
    int memError=0;
    //
    // memory test
    //

    pt=(unsigned int *)(_NONCACHE_STARTADDRESS);
    printf("Memory Test(0x%08x-0x%08x): WR\n",pt,0x33ff0000);//??
    printf("Now memory checking :%16d",0);
    
    while((unsigned int)pt<0x33ff0000) // modified by cha
    {
    	*pt=0x00000000;	data=*pt;
    	if (data != 0x00000000)	printf("\nFAIL:0x%08x=0x%08x (0x00000000 expected).\n",pt,data);
        
    	*pt=0xffffffff;	data=*pt;
    	if (data != 0xffffffff)	printf("\nFAIL:0x%08x=0x%08x (0xffffffff expected).\n",pt,data);
    
    	*pt=0x55555555;	data=*pt;
    	if (data != 0x55555555)	printf("\nFAIL:0x%08x=0x%08x (0x55555555 expected).\n",pt,data);

    	*pt=0xaaaaaaaa;	data=*pt;
    	if (data != 0xaaaaaaaa)	printf("\nFAIL:0x%08x=0x%08x (0xaaaaaaaa expected).\n",pt,data);
    
		*pt=(unsigned int)pt;
	    if(((unsigned int)pt&0x0000ffff)==0)printf("\b\b\b\b\b\b\b\b%8x",pt);
		pt++;
    }
	printf("\b\b\b\b\b\b\b\b%8x",0x33ff0000);
    pt=(unsigned int *)(_NONCACHE_STARTADDRESS);
    printf("\rMemory Test(0x%08x-0x%08x): RD",pt,0x33ff0000);
	
    while((unsigned int)pt<0x32000000)//?
    {
		data=*pt;
		if(data!=(unsigned int)pt)
		{
		    memError=1;
		    printf("\b\bFAIL:0x%x=0x%x\n",pt,data);
		    break;
		}
		pt++;
    }


    if(memError==0)printf("\nO.K.\n");
}


void ClearMemory(void)
{
	int i;
	U32 data;
	int memError=0;
	U32 *pt;
	
	//
	// memory clear
	//
	printf("Clear Memory (%xh-%xh):WR",_NONCACHE_STARTADDRESS,HEAPEND);

	pt=(U32 *)_RAM_STARTADDRESS;
	while((U32)pt < HEAPEND)
	{
		*pt=0x0;
		pt++;
	}
	
	if(memError==0)printf("\b\bO.K.\n");
}
