/**
* Project Name : Jelly(S3C2443) verification project
*
* Copyright 2008 by Embedded Crazy boys.Inc
* All rights reserved.
*
* Project Description :
* This software is only for verifying functions of the Jelly(S3C2443) . 
* Anybody can use this code.
*/

/**
* File Name    : profile.c
* Description  : Jelly(S3C2443)  USB monitor main code
* Author       : http://cafe.naver.com/embeddedcrazyboys
* Dept         : Mobile solution, AP
* Created Date : 2008.07.04
* Version      : 0.0
* History
*   R0.0 (2006.08.): http://cafe.naver.com/embeddedcrazyboys
*/


#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "Option.h"
#include "2443addr.h"
#include "Console.h"
#include "System.h"


/************************* Timer ********************************/
static int intCount;

void __irq IsrWatchdog(void);

void Timer_InitEx(void)
{
	intCount=0;	
	pISR_WDT_AC97=(unsigned int)IsrWatchdog;
	ClearPending(BIT_WDT_AC97);
		rSRCPND=BIT_WDT_AC97;	
	rINTMSK&=~(BIT_WDT_AC97);
	// wdt  AC97 Ȯ ʿ.
}


void Timer_StartEx(void)
{
	int divider=0;
	rWTCON=((PCLK/1000000-1)<<8)|(0<<3)|(1<<2)|(0<<0);	// 16us
	rWTDAT=0xffff;
	rWTCNT=0xffff;   

	// 1/16/(65+1),interrupt enable,reset disable,watchdog enable
	rWTCON=((PCLK/1000000-1)<<8)|(0<<3)|(1<<2)|(0<<0)|(1<<5);   
}



float Timer_StopEx(void)
{
	int count;
	rWTCON=((PCLK/1000000-1)<<8);
	rINTMSK|=BIT_WDT_AC97;// ⵵ Ȯ...
	count=(0xffff-rWTCNT)+(intCount*0xffff);
	return ((float)count*(16e-6));
}


void __irq IsrWatchdog(void)
{
       rINTMSK|=BIT_WDT_AC97;
	ClearPending(BIT_WDT_AC97);
	rSRCPND=BIT_WDT_AC97;	
	intCount++;   	
    rINTSUBMSK&=~BIT_WDT_AC97;//⵵...
}



