/*********************************************************************
;* Project Name : mDirac III
;*
;* Copyright 2005 by Samsung Electronics, Inc.
;* All rights reserved.
;*
;* Project Description :
;* This software is only for verifying functions of the mDirac III
;* Anybody can use this code without our permission.
;**********************************************************************
;*
;*	Description	:	Code for the basic function for IIC.
;*					It can support write and read mode with 7-bit addresses
;*					Can make the 10-bit address write and read mode
;*					with assemble these functions.
;*	
;*	History
;*			R0.0 (2005.9.30) : Y.C.Kwon draft
;*
;**********************************************************************/

#ifndef __IIC_H__
#define __IIC_H__

#ifdef __cplusplus
extern "C" {
#endif

void IIC_open( unsigned int);
void IIC_close( void);
void IIC_Write( unsigned char, char *, unsigned int);
void IIC_Read( unsigned char, char *, unsigned int);
void IIC_Wait( void);
unsigned char IIC_Status( void);

void Test_IIC( void);

#ifdef __cplusplus                                                             
}
#endif                                                                         

#endif    //__IIC_H__
