#include <stdio.h>
#include <string.h>
#include "def.h"
#include "option.h"
#include "2443addr.h"
#include "console.h"
#include "system.h"
#include "sdi.h"

#define INICLK	400000
#define SDCLK	25000000	
#define MMCCLK	17500000	
#define POL	0
#define INT	1
#define DMA	2
#define SDI_Tx_buffer (_NONCACHE_STARTADDRESS)
#define SDI_Rx_buffer (_NONCACHE_STARTADDRESS+(0x800000))


#define Card_OneBlockSize 512

int CMD13(void);    // Send card status
int CMD9(void);
void __irq DMA_end(void);

// Global variables
unsigned int *Tx_buffer;	//128[word]*16[blk]=8192[byte]
unsigned int *Rx_buffer;	//128[word]*16[blk]=8192[byte]
volatile unsigned int rd_cnt;
volatile unsigned int wt_cnt;
volatile unsigned int BlockNum=0;
volatile unsigned int SD_MMC_Ins;
volatile unsigned int TR_end=0;

U32 Wide=0; // 0:1bit, 1:4bit
U32 MMC=0;  // 0:SD  , 1:MMC

int  Maker_ID;
char Product_Name[7]; 
int  Serial_Num;

volatile int RCA;


void * func_sdio_test[][2]=
{	
   // (void *)SDIO_WriteReadTest,       	"SDIO Write & Read   ",
    (void *)SDIO_WriteTest,       	    "SDIO Write          ",
    (void *)SDIO_ReadTest,           	"SDIO Read           ",
    (void *)SDIO_EraseBlock,            "SDIO Block Erase    ",
    0,0
};

#if 0
void SD_MMC_Sub_Irq(void)
{

#if 0
	rGPCON_M= (rGPCON_M & 0xcfff)|(0x0<<12); //GPIO17 -> Input	
	if(rGPDAT & (1<<17) ) {
		printf("\nSD/MMC is extracted.\n");
		SD_MMC_Ins = 0;	
	} 
	else {
		printf("SD/MMC is inserted.\n");
		SD_MMC_Ins = 1;		
	}
	rGPCON_M= (rGPCON_M & 0xcfff)|(0x2<<12); //GPIO17 -> EINT17
	
#else
	rGPCON_L&=~(0x3<<14); //GPIO7 -> Input
	if(rGPDAT & (1<<7) ) {
		printf("\nT-Flash is inserted.\n");
		SD_MMC_Ins = 0;	
	} 
	else {
		printf("T-Flash is extracted.\n");
		SD_MMC_Ins = 1;		
	}
	rGPCON_L |=(0x2<<14); //GPIO7 -> EINT7
	
#endif
}


void __irq SD_MMC_EINT17_Irq(void)
{

	if(rEINTPEND==(1<<17))
		{
		//printf("EINT17 interrupt is occured\n");
		rEINTPEND=(1<<17);
		}
	else
		{
		printf("rEINTPEND=%x\n",rEINTPEND);
		rEINTPEND=(1<<17);
		}
	ClearPending(BIT_EINT15_18);
	
	SD_MMC_Sub_Irq();
	
	rEINTMASK=0xffffff;
	rINTMSK=BIT_ALLMSK;		
}


void Init_SD_MMC_CD_Irq(void)
{
	// Interrupt enable for SD/MMC insert interrupt.
	pISR_EINT15_18= (int)SD_MMC_EINT17_Irq;	// Set interrupt service routine.
	
	rGPCON_M= (rGPCON_M & 0xcfff)|(0x2<<12); //GPIO17 -> EINT17
	rEXTINTC2=rEXTINTC2 & ~(0xf<<24)|(0xf<<24); //filtering & Both edge triggered	
	
	rEINTPEND = 0xffffff;
	rSRCPND = BIT_EINT15_18; //to clear the previous pending states
	rINTPND = BIT_EINT15_18;
	rEINTMASK=~(1<<17);
	rINTMSK=~(BIT_EINT15_18);	
}

#endif

void Test_SDI(void)
{  
	int i;
    RCA=0;
    MMC=0;
    //block=16;   //3072Blocks=1.5MByte, ((2Block=1024Byte)*1024Block=1MByte)
    SD_MMC_Ins=0;    
	
    SD_MMC_SETGPIO();
    
    printf("\n[SDI test]\n");   

    if(!SD_card_init())
    	{
    		printf("\nCard initial fail\n");
    	}
	
    if(!MMC)
    printf("\n[SD card test...PCLK:%d,INICLK:%d,SDCLK:%d]\n",PCLK,INICLK,SDCLK); 
    else
    printf("\n[MMC card test...PCLK:%d,INICLK:%d,MMCCLK:%d]\n",PCLK,INICLK,MMCCLK);
	
	while(1)
    {
		i=0;
		printf("\n\n");
		while(1)
		{   //display menu
	   		printf("%2d:%s",i,func_sdio_test[i][1]);
	    	i++;
	    	if((int)(func_sdio_test[i][0])==0)
	    	{
				printf("\n");
				break;
	    	}
	    	if((i%3)==0)
	    	printf("\n");
		}

		printf("\nSelect (\"-1\" to exit) : ");
		i = GetIntNum();
		if(i==-1) 
	   		break;		// return.
		if( (i<((sizeof(func_sdio_test)-1)/8)) )	// select and execute...
	    	( (void (*)(void)) (func_sdio_test[i][0]) )();
    }
	
}

void SD_MMC_SETGPIO(void)
{
	//rGPECON = (rGPECON& ~(0x3ffc00))|(0x1<<21)|(0x1<<19)|(0x1<<17)|(0x1<<15)|(0x1<<13)|(0x1<<11);
	
	rGPLCON = (rGPLCON & ~(0x3f00ff))|(0x2<<18)|(0x2<<16)|(0x2<<6)|(0x2<<4)|(0x2<<2)|(0x2<<0);
	rGPJCON = (rGPJCON & ~(0xf3000000))|(0x2<<26)|(0x2<<28)|(0x2<<30);
}

void SDIO_ReadTest(void)
{
	U32 i, StartAddr, OneBlockSize, Offset, Testmode, Addr_temp;
	U32 status,transtime=0;
	int j;

	rd_cnt=0;	

	printf("\nSD/MMC block Read test\n");

	printf("\nInput Read Start Address : ");
	StartAddr = GetIntNum();
	Addr_temp = StartAddr;
	
	while((BlockNum == 0) || (BlockNum > 4096))
	{
		printf("Input Read Block Number[1~4096] : ");
		BlockNum = GetIntNum();
	}

	OneBlockSize = Card_OneBlockSize;

	Rx_buffer = (U32 *)SDI_Rx_buffer;
    	for(i=0 ; i<(OneBlockSize*BlockNum)/4 ; i++)	
		*(Rx_buffer+i) = 0x0;    


	//rSDIDSTA |= (1<<7)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2);
	rSDIDSTA = CRC_STAT_FAIL|RECEIVE_CRC_FAIL|DATA_TOUT|DATA_FINISH|BUSY_FINISH;
	rSDIDCON = 0;

	rSDIFSTA |= (1<<16);	//FIFO reset

	if(Wide==0)
		rSDIDCON &= ~WIDE_BUS_EN;
	else
		rSDIDCON |= WIDE_BUS_EN;	

	rSDIDCON |=WORD_TRANSFER|RCV_AFTER_CMD|BLOCK_TRANSFER|BlockNum;
	rSDIDCON |= DATA_RECEIVE_MODE|DATA_TRANSMIT_START;

	printf("\n0:Polling read   1:Interrupt read   2:DMA read");
	printf("\nSelect the test mode : ");
    
       Testmode=GetIntNum();

	switch(Testmode)
		{
			case  POL:
					if(BlockNum<2)	
					{
						SDIO_Command((StartAddr*512), 17, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while(Check_CMDend(17, 1) != 1)								
						SDIO_Command((StartAddr*512), 17, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						//printf("CMD 17 passed\n");
					}
					else	
					{
						SDIO_Command((StartAddr*512), 18, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while(Check_CMDend(18, 1) != 1)	
						SDIO_Command((StartAddr*512), 18, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						//printf("CMD 18 passed\n");
					}

					rSDICSTA = DATA_TIMEOUT|CMD_END|RESP_END;	// Clear cmd_end(with rsp)
					//printf("\nData status=%x",rSDICSTA);

					printf("\nTotal size =%x",OneBlockSize*BlockNum/4);
					while(rd_cnt<(OneBlockSize*BlockNum)/4)	
					{
						if(rSDIDSTA & DATA_TOUT) // Check timeout 
						{
							printf("\nData status=%x",rSDICSTA);
							rSDIDSTA |= DATA_TOUT;  // Clear timeout flag
							break;
						}
			
						status = rSDIFSTA;	//If FIFO is not empty, receive data from Data Register(rSDIDAT0)
						if(status& RX_FIFO_AVAILABLE_DETECT)	// Is Rx data?
						{
							*Rx_buffer++ = rSDIDAT;
							rd_cnt++;
						}
					}

					printf("\nRead Count =%x",rd_cnt);
					break;
	
			case INT:
				pISR_SDI_0=(unsigned)Rd_Int;
				rINTMSK &= ~(BIT_SDI0);	    
			    	rSDIIMSK=5;	// Last & Rx FIFO half int.
				
			    	if(BlockNum<2)	
					{
						SDIO_Command((StartAddr*512), 17, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while(Check_CMDend(17, 1) != 1)	
						SDIO_Command((StartAddr*512), 17, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					}
					else	
					{
						SDIO_Command((StartAddr*512), 18, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while(Check_CMDend(18, 1) != 1)	
						SDIO_Command((StartAddr*512), 18, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					}
				
	    			rSDICSTA = DATA_TIMEOUT|CMD_END|RESP_END;	// Clear cmd_end(with rsp)

	    			while(rd_cnt<128*BlockNum);

	    			rINTMSK |= (BIT_SDI0);
	    			rSDIIMSK=0;	// All mask
	    			break;

			case DMA:
				printf("\nDMA mode data write\n");

				pISR_DMA=(unsigned)DMA_end;
	    			rINTMSK&=~(BIT_DMA);
				rINTSUBMSK&=~(BIT_SUB_DMA0);  
	
	  		    	rDISRC0 = (U32)(SDIDAT);	
			    	rDISRCC0 = (1<<1) | (1<<0);	
				rDIDST0 = (int)(Rx_buffer);	
				rDIDSTC0 = (0<<1)|(0<<0);	
				rDCON0 = (1<<31)|(0<<30)|(1<<29)|(1<<28)|(0<<27)|(1<<24)|(1<<22)|(2<<20) | (128*BlockNum)/4;
				rDMASKTRIG0 = (0<<2)|(1<<1)|0;    //no-stop, DMA0 channel on, no-sw trigger
				rDMAREQSEL0 = (10 <<1) | 1;

				StartStopwatch();

	    			if(BlockNum<2)	
				{
					SDIO_Command((StartAddr*512), 17, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					while(Check_CMDend(17, 1) != 1)	
					SDIO_Command((StartAddr*512), 17, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
				}
				else	
				{
					SDIO_Command((StartAddr*512), 18, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					while(Check_CMDend(18, 1) != 1)	
					SDIO_Command((StartAddr*512), 18, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
				}

	    			rSDICSTA = DATA_TIMEOUT|CMD_END|RESP_END;	// Clear cmd_end(with rsp)

				rSDIDCON |=BURST4_EN|WORD_TRANSFER|TRANS_AFTER_RESP|BLOCK_TRANSFER|DMA_EN|BlockNum;
				rSDIDCON |= DATA_RECEIVE_MODE|DATA_TRANSMIT_START;

				if(Wide!=0)
					rSDIDCON |= WIDE_BUS_EN;
				else
					rSDIDCON &= ~WIDE_BUS_EN;
				
	    			while(!TR_end);
				rINTMSK |= (BIT_DMA);
				rINTSUBMSK |= (BIT_SUB_DMA0);
	    			TR_end=0;
	    			rDMASKTRIG0=(1<<2);	//DMA0 stop
				
			default : break;	
		}
		
		if(!Check_DATend()) 
			printf("\nData End Error....\n");


	 	if(BlockNum>1)
	 		{
	 			
				SDIO_Command(0, 12, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
				while(Check_CMDend(12, 1) != 1)  
					SDIO_Command(0, 12, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
				rSDICSTA = CMD_END|RESP_END;;	// Clear cmd_end(with rsp)
	 		}

		transtime = EndStopwatch();
		CalculationBPS_NORMALSD_MMC(transtime);
/*
		Rx_buffer = (U32 *)SDI_Rx_buffer;
		for(j=0 ; j<(OneBlockSize*BlockNum)/4 ; j++)
		   	{
			      	if(j%4 == 0)
			   		printf("\n0x%04xh : ",Addr_temp);
			       	printf("0x%08x ",*Rx_buffer++);
			       	Addr_temp += 4;
			}
*/
		BlockNum = 0;
		printf("\n");    
	

}

void SDIO_WriteTest(void)
{
	U32 i, StartAddr,  OneBlockSize, Offset, Testmode;
	//U32 BlockNum=0;
	U32 status;
	U32 transtime;

	wt_cnt=0;
	
	printf("\nSD/MMC block write test\n");

	printf("\n0:Polling write   1:Interrupt write   2:DMA write");
	printf("\nSelect the test mode : ");
    
       Testmode=GetIntNum();
    	
	printf("\nInput Write Start Address : ");
	StartAddr = GetIntNum();

	while((BlockNum == 0) || (BlockNum > 4096))
	{
		printf("Input Write Block Number[1~4095] : ");
		BlockNum = GetIntNum();
	}
	
	printf("Input Write Data Offset : ");
	Offset = GetIntNum();

	OneBlockSize = Card_OneBlockSize;

	Tx_buffer = (U32 *)SDI_Tx_buffer;
    	for(i=0 ; i<(OneBlockSize*BlockNum)/4 ; i++)	
		*(Tx_buffer+i) = (i+Offset);    

	rSDIFSTA |=(1<<16); //FIFO reset
	rSDIDCON=(2<<22)|(1<<20)|(1<<17)|(Wide<<16)|(1<<14)|(3<<12)|(BlockNum<<0);

	switch(Testmode)
		{
			case  POL:
				printf("\nPolling mode data write\n");

				if(BlockNum<2)//single block
					{
						SDIO_Command((StartAddr*512), 24, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while((Check_CMDend(24, 1) !=1))
							SDIO_Command((StartAddr*512), 24, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);					
					}
				else//multi block
					{
						SDIO_Command((StartAddr*512), 25, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while((Check_CMDend(25, 1) !=1))
							SDIO_Command((StartAddr*512), 25, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);	
					}
				rSDICSTA = CMD_END|RESP_END;	// Clear cmd_end(with rsp)
				printf("\nBlock zise=%x\n",OneBlockSize*BlockNum/4);
				while(wt_cnt < (OneBlockSize*BlockNum)/4)
					{
						status = rSDIFSTA;
						if(status && TX_FIFO_AVAILABLE_DETECT) 
							{
	    						rSDIDAT = *Tx_buffer++;
		  		 			wt_cnt++;
							}						
					}

				printf("\nWrite count=%x\n",wt_cnt);
				break;

			case INT:
				printf("\nInterrupt mode data write\n");
				
				pISR_SDI_0=(unsigned)Wt_Int;
	    			rINTMSK &= ~(BIT_SDI0);

	    			rSDIIMSK=0x10;  // Tx FIFO half int.

				StartStopwatch();

	    			if(BlockNum<2)//single block
					{
						SDIO_Command((StartAddr*512), 24, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while((Check_CMDend(24, 1) !=1))
							SDIO_Command((StartAddr*512), 24, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					}
				else//multi block
					{
						SDIO_Command((StartAddr*512), 25, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while((Check_CMDend(25, 1) !=1))
							SDIO_Command((StartAddr*512), 25, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					}
				rSDICSTA |= CMD_END|RESP_END;	// Clear cmd_end(with rsp)

	    			while(!TR_end);

	    			rINTMSK |= (BIT_SDI0);
	    			TR_end=0;
	    			rSDIIMSK=0;	// All mask
	    			break;
					
			case DMA:
				printf("\nDMA mode data write\n");

				pISR_DMA=(unsigned)DMA_end;	    			
				rINTMSK&=~(BIT_DMA);
				rINTSUBMSK&=~(BIT_SUB_DMA0);  
	
			    	rDISRC0 = (int)(Tx_buffer);	
			    	rDISRCC0 = (0<<1) | (0<<0);	
				rDIDST0 = (U32)(SDIDAT);	
				rDIDSTC0 = (1<<1)|(1<<0);	
				rDCON0 = (1<<31)|(0<<30)|(1<<29)|(1<<28)|(0<<27)|(1<<24)|(1<<22)|(2<<20) |((128*BlockNum)/4);
				rDMASKTRIG0 = (0<<2)|(1<<1)|0;    //no-stop, DMA0 channel on, no-sw trigger
				rDMAREQSEL0 = (10 <<1) | 1;

				StartStopwatch();

				if(BlockNum<2)//single block
					{
						SDIO_Command((StartAddr*512), 24, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while((Check_CMDend(24, 1) !=1))
							SDIO_Command((StartAddr*512), 24, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					}
				else//multi block
					{
						SDIO_Command((StartAddr*512), 25, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
						while((Check_CMDend(25, 1) !=1))
							SDIO_Command((StartAddr*512), 25, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
					}
				rSDICSTA |= CMD_END|RESP_END;	// Clear cmd_end(with rsp)

				if(Wide!=0)
					rSDIDCON |= WIDE_BUS_EN;
				else
					rSDIDCON &= ~WIDE_BUS_EN;

				//printf("Origin TC=%x\n",(rDSTAT0&0xff));

				rSDIDCON |=BURST4_EN|WORD_TRANSFER|TRANS_AFTER_RESP|BLOCK_TRANSFER|DMA_EN|BlockNum;
				rSDIDCON |= DATA_TRANSMIT_MODE|DATA_TRANSMIT_START;
				
				while(!TR_end);
					
				rINTMSK |= (1<<20);
				rINTSUBMSK |= (1<<27);
				TR_end=0;
				rDMASKTRIG0 |=(1<<2);//DMA Stop 				
				
			default : break;		
				
		}		
	
		while(!Check_DATend()) ;
			//printf("\nData End Error\n");
		rSDIDCON=rSDIDCON&~(7<<12);		//YH 040220, Clear Data Transfer mode => no operation, Cleata Data Transfer start
    		rSDIDSTA |= DATA_FINISH;	// Clear data Tx/Rx end

		if(BlockNum>1)
    			{
				rSDIDCON=BUSY_AFTER_CMD|BLOCK_TRANSFER|WIDE_BUS_DIS|DATA_TRANSMIT_START|ONLYBUSY_CHECK|(BlockNum<<0); 	
									
				SDIO_Command(0, 12, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
				while(Check_CMDend(12, 1) != 1)	
     					SDIO_Command(0, 12, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);

				rSDICSTA = CMD_END|RESP_END;	// Clear cmd_end(with rsp)

				if(!Check_BUSYend()) 
	    				//printf("error\n");

				rSDIDSTA|= DATA_FINISH;	//! Should be cleared by writing '1'.
			}

		transtime = EndStopwatch();
		CalculationBPS_NORMALSD_MMC(transtime);

		BlockNum =0;

}
	
void SDIO_EraseBlock(void)
{
	U32 StartAddr, EndAddr;	
	
	printf("\nSD/MMC block erase test\n");

	printf("\nInput Write Start Block Address(0x200, 0x400...) : ");  //ex) 0x200[512bytes], 0x400, 0x800.....
	StartAddr = GetIntNum();

	printf("Input Write End Block Address(0x200, 0x400...) : ");  //ex) 0x200[512bytes], 0x400, 0x800.......
	EndAddr = GetIntNum();
	#if 0
	SDIO_Command(StartAddr, 32, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
	while((Check_CMDend(32, 1) !=1))
		{
			SDIO_Command(StartAddr, 32, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
			printf("\nCMD32 fail\n");			
		}	
	
	printf("\nCMD32 OK\n");
	#else

	if(MMC == 0)
		{
		SDIO_Command(StartAddr, 32, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);
		while(Check_CMDend(32, 1) != 1)	
		 	SDIO_Command(StartAddr, 32, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);

		 rSDICSTA = CMD_END|RESP_END;	// Clear cmd_end(with rsp)

		 SDIO_Command(EndAddr, 33, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);
		while(Check_CMDend(33, 1) != 1)	
		 	SDIO_Command(EndAddr, 33, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);

		rSDICSTA = CMD_END|RESP_END;	// Clear cmd_end(with rsp)
		}
	else if(MMC == 1)
		{
		SDIO_Command(StartAddr, 35, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);
		while(Check_CMDend(35, 1) != 1)	
		 	SDIO_Command(StartAddr, 35, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);

		 rSDICSTA = CMD_END|RESP_END;	// Clear cmd_end(with rsp)

		 SDIO_Command(EndAddr, 36, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);
		while(Check_CMDend(36, 1) != 1)	
		 	SDIO_Command(EndAddr, 36, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);

		rSDICSTA = CMD_END|RESP_END;	// Clear cmd_end(with rsp)		
		}
	
	#endif
	
	rSDIDSTA |= (1<<7)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2);
	rSDIDCON = 0;

	if(Wide==0)
		rSDIDCON &= ~WIDE_BUS_EN;
	else
		rSDIDCON |= WIDE_BUS_EN;		

	rSDIDCON |= BUSY_AFTER_CMD|BLOCK_TRANSFER|BlockNum;
	rSDIDCON |= ONLYBUSY_CHECK|DATA_TRANSMIT_START;


	SDIO_Command(0, 38, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
	while(Check_CMDend(38, 1) != 1)	
     	SDIO_Command(0, 38, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);

	rSDICSTA = CMD_END|RESP_END;	// Clear cmd_end(with rsp)
	
	if(!Check_BUSYend()) 
	   	printf("\nBusy Check Error...\n");

	rSDIDSTA = (1<<3);
	printf("\n[SD/TFlash card Erase Block Test...End]\n");
	

}

int SD_card_init(void)
{
	int i, Card_State, blocksize;
	char key;
	int uArg;
	U32 C_SIZE, C_SIZE_MULT, READ_BL_LEN, CardSize, OneBlockSize;
   printf("PCLK=U%ld\n",PCLK);
	rSDIPRE=PCLK/(INICLK)-1;	// Clock setting
   printf("rSDIPRE=U%ld\n",rSDIPRE);
	SDIO_TypeSetting(SDIO_SD_TYPE, SDIO_TYPE_A);// clock type setting	
	rSDICON |= ENCLK;	//Clock enable
	rSDIFSTA |= (1<<16);//FIFO reset

	SDIO_BlockSizeSetting(512);	//block size setting
	rSDIDTIMER |=0x7fffff;	//busy timer setting

	Delay(0x1000);		// Wait 74SDCLK for MMC card

	SDIO_Command(0x0, 0x0, SDIO_NO_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
	Check_CMDend(0,0);
//-------------------------------------------------------------------------------------//
#if 0
	printf("\nCMD8\n");
	SDIO_Command(0x1aa, 0x8, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//SD Card version Check
	while(Check_CMDend(8,1) != 1)
		SDIO_Command(0x1aa, 0x8, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//SD Card version Check
	printf("rSDIRSP0 = %x\n",rSDIRSP0);
#endif
//-------------------------------------------------------------------------------------//
	printf("\nEnter to the Idle State\n");

	if(Check_MMC_OCR()) 
    	{
		printf("\n\n[In MMC Memory ready....]\n");
		MMC = 1;
    	}

	if(MMC == 0)
	{
		printf("\nChecking the SD/TFlash Memory....");
	    	if(Check_SD_OCR()) 
        		printf("\n\n[In SD/TFlash Memory Ready State....]\n");
	    	else
    		{
		printf("\n\nInitialize fail\nNo Card assertion\n");
        	return 0;
	    	}
	}

//-------------------------------------------------------------------------------------//

 	printf("\nCMD2 : CID response\n");
	SDIO_Command(0x0, 2, SDIO_WAIT_RESP, SDIO_LONG_RESP, SDIO_WITHOUT_DATA);
		while(Check_CMDend(2, 1) != 1)
			SDIO_Command(0x0, 2, SDIO_WAIT_RESP, SDIO_LONG_RESP, SDIO_WITHOUT_DATA);
	printf("\n - Product Name : %c%c%c%c%c",(rSDIRSP0&0xFF),((rSDIRSP1>>24)&0xFF),((rSDIRSP1>>16)&0xFF),((rSDIRSP1>>8)&0xFF),(rSDIRSP1&0xFF));		

//-------------------------------------------------------------------------------------//

	printf("\nCMD3 : assign relative address\n");
   	SDIO_Command((MMC<<16), 3, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
		while( Check_CMDend(3, 1) !=1)
			{
				SDIO_Command((MMC<<16), 3, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
			}
		
//-------------------------------------------------------------------------------------//

	if(MMC) 
    	{		
		RCA=1;
		SDIO_PrescalerSetting(MMCCLK);
		
		while(PCLK/(rSDIPRE+1) > 20000000)
			rSDIPRE = rSDIPRE+1; 

		//rSDIPRE = 2; 
		
        	printf("\nMMC Frequency is %dHz\n",(PCLK/(rSDIPRE+1)));
   	 }
    	else 
    	{
		SDIO_PrescalerSetting(SDCLK);
		while(PCLK/(rSDIPRE+1) > 25000000)
			rSDIPRE = rSDIPRE+1; 
		printf("\nSD Frequency is %dHz\n",(PCLK/(rSDIPRE+1)));
		RCA = ( rSDIRSP0 & 0xffff0000 )>>16;
		  printf("RCA=0x%x\n",RCA);
    	}	

/*
	uArg=(3<<24)|(185<<16)|(1<<8); // Change to the high-speed mode
	
	SDIO_Command(uArg, 6, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//ACMD6 select bus width
	while((Check_CMDend(6, 1) !=1))
		SDIO_Command(uArg, 6, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//ACMD6 select bus width

	rSDICSTA |= CMD_END|RESP_END;	
	printf("\nMoviNand high speed mode set\n");
*/

//-------------------------------------------------------------------------------------//

	SDIO_Command(RCA<<16, 9, SDIO_WAIT_RESP, SDIO_LONG_RESP, SDIO_WITHOUT_DATA);
		while(Check_CMDend(9, 1) != 1)
			SDIO_Command(RCA<<16, 9, SDIO_WAIT_RESP, SDIO_LONG_RESP, SDIO_WITHOUT_DATA);

	READ_BL_LEN = ((rSDIRSP1>>16)&0xF);
	C_SIZE = ((rSDIRSP1&0x3ff)<<2) | ((rSDIRSP2>>30)&0x3);
	C_SIZE_MULT = ((rSDIRSP2>>15)&0x7);

	CardSize = (1<<READ_BL_LEN)*(C_SIZE+1)*(1<<(C_SIZE_MULT+2))/1048576;
	OneBlockSize = (1<<READ_BL_LEN);

	printf("\n READ_BL_LEN: %d",READ_BL_LEN);	
	printf("\n C_SIZE: %d",C_SIZE);	
	printf("\n C_SIZE_MULT: %d\n",C_SIZE_MULT);	

	printf("\n One Block Size: %dByte",OneBlockSize);	
	printf("\n Total Card Size: %dMByte\n",CardSize+1);	

//-------------------------------------------------------------------------------------//

	CARD_SEL_DESEL(1);//Enter Card state to the transfer mode

	

	SDIO_Command(512, 16, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
		while(Check_CMDend(16, 1) != 1)
			SDIO_Command(512, 16, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
	printf("\nSet Block Length");	


	if(!MMC)
		{	
			Set_4bit_bus();
		}
	else
		{
			Set_1bit_bus();
			//Set_4bit_bus_MoviNand();
		}
	
	return 1;
    }

void Set_1bit_bus(void)
{
	Wide=0;
	SET_BUSWIDTH();
	printf("\n****1bit bus****\n");
}

void Set_4bit_bus(void)
{
	Wide=1;
       SET_BUSWIDTH();
       printf("\n****4bit bus****\n");
}

void Set_4bit_bus_MoviNand(void)
{
	Wide=1;
       SET_BUSWIDTH_MoviNand();
       printf("\n****4bit bus****\n");
}

void SET_BUSWIDTH(void)
{

	SDIO_Command((RCA<<16), 55, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);//befoe using ACMD
	while((Check_CMDend(55, 1) !=1))
		{
			SDIO_Command((RCA<<16), 55, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);//befoe using ACMD
		}

	SDIO_Command((Wide<<1), 6, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//ACMD6 select bus width
	while((Check_CMDend(6, 1) !=1))
		SDIO_Command((Wide<<1), 6, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//ACMD6 select bus width

	rSDICSTA |= CMD_END|RESP_END;	
}

void SET_BUSWIDTH_MoviNand(void)
{
	int uArg;

	uArg=((3<<24)|(183<<16)|(1<<8));
	
	SDIO_Command(uArg, 6, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//ACMD6 select bus width
	while((Check_CMDend(6, 1) !=1))
		SDIO_Command(uArg, 6, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);//ACMD6 select bus width

	rSDICSTA |= CMD_END|RESP_END;	
}

void CARD_SEL_DESEL(U8 sel_desel)
{
	printf("\nCMD7 : Command toggles a card between the stand-by and transfer state\n");
	if(sel_desel)
		{
			printf("\nCMD7 : Select\n");
			SDIO_Command((RCA<<16), 7, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
			if((Check_CMDend(7, 1) !=1)||(rSDIRSP0 != 0x800))//entering the standby mode
				SDIO_Command((RCA<<16), 7, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);

			rSDICSTA |=CMD_END|RESP_END;
			printf("\nEntered to the Transfer state\n");			
		}
	else
		{
			printf("\nCMD7 : Deselect\n");
			SDIO_Command((RCA<<16), 7, SDIO_NO_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
			if((Check_CMDend(7, 0) !=1))
				SDIO_Command((RCA<<16), 7, SDIO_NO_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);

			rSDICSTA |= CMD_END;
			printf("\nEntered to the Stand-by State\n");			
		}
	

}


void SDIO_PrescalerSetting(U32 BaudRate)
{
	rSDIPRE = (PCLK/BaudRate) - 1;
}

void SDIO_Command(U32 CmdArg, U32 Command, U32 WaitResp, U32 LongResp, U32 WithData)
{
	U32 CmdIndex;
	
	rSDICARG = rSDICARG & ~(0xffffffff) | CmdArg;

	CmdIndex = Command | 0x40;
	rSDICCON = (WithData<<11)|(LongResp<<10)|(WaitResp<<9)|(CmdIndex);
	//printf(" CmdArg=0x%x ,CmdIndex=0x%x , Wait response =0x%x long response=0x%x withdata or not=0x%x\n",CmdArg,Command,WaitResp,LongResp,WithData);	
	//Command Start
	rSDICCON |= (1<<8);
}

void SDIO_BlockSizeSetting(U32 Size)
{
	rSDIBSIZE = (Size & 0xFFF);
}


void SDIO_TypeSetting(U32 ClkType, U32 ByteType)
{
	if(ClkType == SDIO_SD_TYPE)
		rSDICON &= ~CLOCK_TYPE;
	else if(ClkType == SDIO_MMC_TYPE)
		rSDICON |= CLOCK_TYPE;

	if(ByteType == SDIO_TYPE_A)
		rSDICON &= ~BYTE_ORDER;
	else if(ByteType == SDIO_TYPE_B)
		rSDICON |= BYTE_ORDER;		
}

#if 1
int Check_CMDend(int cmd, int be_resp)
//0: Timeout
{
    int finish0;

    if(!be_resp)    // No response
    {
    	finish0=rSDICSTA;
		while((finish0&CMD_END)!=CMD_END)	// Check cmd end
	    finish0=rSDICSTA;

	rSDICSTA=finish0;// Clear cmd end state

	return 1;
    }
    else	// With response
    {
    	finish0=rSDICSTA;
	while( !( ((finish0&RESP_END)==RESP_END) | ((finish0&CMD_TOUT)==CMD_TOUT) ))    // Check cmd/rsp end
	finish0=rSDICSTA;
	if(cmd==1 | cmd==41)	// CRC no check, CMD9 is a long Resp. command.

	{
	    if( (finish0&0xf00) != CMD_END|RESP_END )  // Check error
	    {
		rSDICSTA=finish0;   // Clear error state
		if(((finish0&CMD_TOUT)==CMD_TOUT))
		    return 0;	// Timeout error
    	    }
	    rSDICSTA=finish0;	// Clear cmd & rsp end state
	}
	else	// CRC check
	{
	    if( (finish0&0x1f00) != CMD_END|RESP_END)	// Check error
	    {
		//printf("CMD%d:rSDICSTA=0x%x, rSDIRSP0=0x%x\n",cmd, rSDICSTA, rSDIRSP0);
		rSDICSTA=finish0;   // Clear error state

		if(((finish0&CMD_TOUT)==CMD_TOUT))
		    return 0;	// Timeout error
    	    }
	    rSDICSTA=finish0;
	}
	return 1;
    }
}
#else
int Check_CMDend(int cmd, int be_resp)
//0: Timeout
{
    int finish0;

    if(!be_resp)    // No response
    {
    	finish0=rSDICSTA;
		while((finish0&0x800)!=0x800)	// Check cmd end
	    finish0=rSDICSTA;

	rSDICSTA=finish0;// Clear cmd end state

	return 1;
    }
    else	// With response
    {
    	finish0=rSDICSTA;
	while( !( ((finish0&0x200)==0x200) | ((finish0&0x400)==0x400) ))    // Check cmd/rsp end
	finish0=rSDICSTA;
	if(cmd==1 | cmd==41)	// CRC no check, CMD9 is a long Resp. command.

	{
	    if( (finish0&0xf00) != 0xa00 )  // Check error
	    {
		rSDICSTA=finish0;   // Clear error state

		if(((finish0&0x400)==0x400))
		    return 0;	// Timeout error
    	    }
	    rSDICSTA=finish0;	// Clear cmd & rsp end state
	}
	else	// CRC check
	{
	    if( (finish0&0x1f00) != 0xa00 )	// Check error
	    {
		printf("CMD%d:rSDICSTA=0x%x, rSDIRSP0=0x%x\n",cmd, rSDICSTA, rSDIRSP0);
		rSDICSTA=finish0;   // Clear error state

		if(((finish0&0x400)==0x400))
		    return 0;	// Timeout error
    	    }
	    rSDICSTA=finish0;
	}
	return 1;
    }
}
#endif

int Check_BUSYend(void)
{
    int finish;

    finish=rSDIDSTA;
    //printf("\nBusy end =%x",finish);
    while( !( ((finish&0x08)==0x08) | ((finish&0x20)==0x20) ))
	finish=rSDIDSTA;

    while( (finish&(0x1<<3)) != 0x8 )
    {
       // printf("\nDATA:finish=0x%x\n", finish);
        finish=rSDIDSTA;
        //return 0;
    }
   rSDIDSTA=0xf4;  //clear error state	
    return 1;
}


int Check_MMC_OCR(void)
{
    int i;


    //-- Negotiate operating condition for MMC, it makes card ready state
    for(i=0;i<200;i++)	//Negotiation time is dependent on CARD Vendors.
    {
    	SDIO_Command(0xff8000, 1, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);

	if(Check_CMDend(1, 1) && (rSDIRSP0>>16)==0x80ff) //[31]:Card Power up status bit (busy)
	{
	    //rSDICSTA=0xa00;	// Clear cmd_end(with rsp)
	    rSDICSTA |= CMD_END|RESP_END;
	    return 1;	// Success
	}
    }
    //rSDICSTA=0xa00;	// Clear cmd_end(with rsp)
    rSDICSTA |= CMD_END|RESP_END;
    return 0;		// Fail
}

#if 0
int Check_DATend(void)
{
    int finish;

	finish=rSDIDSTA;
	
    while( !( ((finish&0x10)==0x10) || ((finish&0x20)==0x20) ))// Chek timeout or data end
    	{
    		//printf("\nData End Check =%x",finish);
		finish=rSDIDSTA;
    	}

    if( (finish &0x10) != 0x10 )
    {
        //printf("\nDATA:finish=0x%x\n", finish);
        rSDIDSTA=finish;  // Clear error state
        return 0;
    }
    return 1;
}

#else
int Check_DATend(void)
{
    int finish;

    finish=rSDIDSTA;
	//printf("DATA:finish=0x%x\n", finish);
	//printf("DATA end check\n");
    while( !((finish&DATA_FINISH)==DATA_FINISH))// Chek timeout or data end
    	{
    		//printf("\nData End Check =%x",finish);
		finish=rSDIDSTA;
    	}

    if( (finish&0xfc) != DATA_FINISH )
    {
        //printf("DATA:finish=0x%x\n", finish);
        rSDIDSTA=0xec;  // Clear error state
        return 0;
    }
    return 1;
}
#endif

int Check_SD_OCR(void)
{
    int i,j=0;

    //-- Negotiate operating condition for SD, it makes card ready state
    for(i=0;i<200;i++)	//If this time is short, init. can be fail.
    {
    	SDIO_Command((RCA<<16), 55, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITH_DATA);
	while(Check_CMDend(55, 1) != 1)
		{
			printf("\nCommand55 Fail...");
			return 0;
		}	
	
	SDIO_Command(0xff8000, 41, SDIO_WAIT_RESP, SDIO_SHORT_RESP, SDIO_WITHOUT_DATA);
    	if( Check_CMDend(41, 1) & rSDIRSP0==0x80ff8000 ) 
	{
	    rSDICSTA=0xa00;	// Clear cmd_end(with rsp)
	    return 1;	// Success	    
	}
	Delay(200); // Wait Card power up status
    }
    rSDICSTA=0xa00;	// Clear cmd_end(with rsp)
    return 0;		// Fail
}


void __irq DMA_end(void)
{
	//printf("\nDMA ISR\n");
	rSUBSRCPND |= BIT_SUB_DMA0;
	ClearPending(BIT_DMA);    
    	TR_end=1;
}

void __irq Rd_Int(void)
{
    	U32 i,status;

	ClearPending(BIT_SDI0);
	rINTMSK |= (BIT_SDI0);
	
	status=rSDIFSTA;
	if( (status&0x200) == 0x200 )	// Check Last interrupt?
	{
	for(i=(status & 0x7f)/4;i>0;i--)
	{
	    *Rx_buffer++=rSDIDAT;
	    rd_cnt++;
	}
	rSDIFSTA=rSDIFSTA&0x200;	//Clear Rx FIFO Last data Ready, YH 040221
	}
	else if( (status&0x80) == 0x80 )	// Check Half interrupt?
	{
	    for(i=0;i<8;i++)
	    	{
			*Rx_buffer++=rSDIDAT;
			rd_cnt++;
		}
	}
		
	rINTMSK &= ~(BIT_SDI0);
}

void __irq Wt_Int(void)
{
    ClearPending(BIT_SDI0);
	rINTMSK |= (BIT_SDI0);

    rSDIDAT=*Tx_buffer++;
    wt_cnt++;

    if(wt_cnt==128*BlockNum)
    {
	rINTMSK |= BIT_SDI0;
	rSDIDAT=*Tx_buffer;
	TR_end=1;
    }
	
	rINTMSK &= ~(BIT_SDI0);
}

void CalculationBPS_NORMALSD_MMC(int Time)
{
	float x=0;
	int y=0;
	float bps=0;

	x = (float)((float)1000000/(float)Time); //Unit is usec

	y = (BlockNum+1) * 512 * 8;
	
	bps = x*(float)y;
	
	printf("\n\n\nTransfer Time = %dusec",Time);
	printf("\nTransferSize = %dKByte",y/(8*1024));
	printf("\nBPS = %fMByte/sec\n\n",bps/(1000000*8));
}
